unit Unit3; // scaff records

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

// Object Scaff
  type Tcategory=record
    Name:String[32];
    Health,Regeneration,Stamina:Integer;
    RecrutionCosts,Nimbleness,Intelligence,Strength,Tactic,BuildingAttack:Integer;
    Workforce:real;
  end;

  type TvicinityAdaption=record
    Vicinity:String[32]; // Tsoil.Name
    Ammount:Integer;
  end;

  type Ttroop=record
    Category:Tcategory;
    Health,Regeneration,Stamina,RecrutionCosts,Level,Owner:Integer;
    Attack,Defence:Integer;
    VicinityAdaption:TvicinityAdaption;
  end;

  type Tressource=record
    Name:String[32];
  end;

  type Tres_ammount=record
    Ressource:Tressource;
    Value:integer;
  end;

  type Tsoil=record
    Name:String[32];
    Gold_M,Food_M,Material_M,GemStone_M:Integer;
    Clearing_Boni:array of Tres_ammount;
    Clearing_Result:String[32];
  end;

  type Tprop=record
    Name:String[32];
    EffectID:String[4]; // Wonder : wnd1, Market : mrkt
  end;

  type Tbuilding=record
    Name:String[32];
    Health:Integer;
    BuildingCosts:Tres_ammount;
    Props:array of Tprop;
  end;

  type Tfield=record
    Soil:Tsoil;
    Building:Tbuilding;
    Garnision:Ttroop;
  end;

  type Tmap=record
    Name:String[32];
    Map_Length:Integer;
    Field:array of Tfield;
  end;

  type Tplayer=record
    Name:String[32];
    Gold,Food,Material,GemStone:Integer;
    Rooster:array of Ttroop;
  end;

  type Tgame=record
    Name:String[32];
    Map:Tmap;
    Player:array of Tplayer;
  end;

// List & Main Objects / Props Scaff
    var
      i:integer;
      Game:Tgame;
                 MapList:array of TMap;
                 SoilList:array of Tsoil;

      RessourceList:array of Tressource;

      BuildingList:array of Tbuilding;     TroopList:array of Ttroop;
      PropList:array of Tprop;             CategoryList:array of Tcategory;

implementation

end.
